/*
	RDOT_ECD.h - Library for driving rdot's electrochromic display
	Created by Philip Holgersson - rdot AB, Nov 22, 2019
*/

#ifndef _RDOT_ECD
#define _RDOT_ECD

#include "Arduino.h"

class RDOT_ECD
{
	public:
		RDOT_ECD(int counter_electrode, int segments[], int number_of_segments, int counter_voltage, int switching_time);
		void init();
		void set(bool next_state[]);
		void setNumber1x7(int digit);
		void setNumber2x7(int digit);
		void setBar(int digit);
		void refresh();
	private: 
		int _counter_electrode; 
		int _counter_voltage;
		int _number_of_segments;
		int _segments[15];
		int _switching_time;
		bool _current_state[15];
		
		//Seven segment display states
		bool _seven_seg_states[10][7]={
			{1,1,1,1,1,1,0},
			{0,1,1,0,0,0,0},
			{1,1,0,1,1,0,1},
			{1,1,1,1,0,0,1},
			{0,1,1,0,0,1,1},
			{1,0,1,1,0,1,1},
			{1,0,1,1,1,1,1},
			{1,1,1,0,0,0,0},
			{1,1,1,1,1,1,1},
			{1,1,1,1,0,1,1}
		};

		//2x7 electrode configuration
		int _2x7_seven_1[7] = {1,0,7,6,5,2,4};
		int _2x7_seven_2[7] = {13,12,10,9,8,14,11};
		int _2x7_sign = 3;

		//1x7 electrode condiguration
		int _1x7_seven_1[7] = {6,5,4,3,2,0,1};

		//Bar graph display
		int _bar[7] = {3,2,4,1,5,0,6};

		void highImpMode();
};

#endif